# mypy-boto3-iotsitewise

[![PyPI - mypy-boto3-iotsitewise](https://img.shields.io/pypi/v/mypy-boto3-iotsitewise.svg?color=blue)](https://pypi.org/project/mypy-boto3-iotsitewise)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-iotsitewise.svg?color=blue)](https://pypi.org/project/mypy-boto3-iotsitewise)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

Type annotations for
[boto3.IoTSiteWise 1.13.24](https://boto3.amazonaws.com/v1/documentation/api/1.13.24/reference/services/iotsitewise.html#IoTSiteWise) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 1.1.1](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-iotsitewise](#mypy-boto3-iotsitewise)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

### Type checking

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `IoTSiteWise` service.

```bash
python -m pip install boto3-stubs[iotsitewise]

# update installed packages index
mypy_boto3
```

Use `boto3` with `mypy_boto3` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3 import iotsitewise
# alternative import if you do not want to install mypy_boto3 package
# import mypy_boto3_iotsitewise as iotsitewise

# Use this client as usual, now mypy can check if your code is valid.
# Check if your IDE supports function overloads,
# you probably do not need explicit type annotations
# client = boto3.client("iotsitewise")
client: iotsitewise.IoTSiteWiseClient = boto3.client("iotsitewise")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: iotsitewise.IoTSiteWiseClient = session.client("iotsitewise")


# Waiters need type annotation on creation
asset_active_waiter: iotsitewise.AssetActiveWaiter = client.get_waiter("asset_active")
asset_model_active_waiter: iotsitewise.AssetModelActiveWaiter = client.get_waiter("asset_model_active")
asset_model_not_exists_waiter: iotsitewise.AssetModelNotExistsWaiter = client.get_waiter("asset_model_not_exists")
asset_not_exists_waiter: iotsitewise.AssetNotExistsWaiter = client.get_waiter("asset_not_exists")
portal_active_waiter: iotsitewise.PortalActiveWaiter = client.get_waiter("portal_active")
portal_not_exists_waiter: iotsitewise.PortalNotExistsWaiter = client.get_waiter("portal_not_exists")

# Paginators need type annotation on creation
get_asset_property_aggregates_paginator: iotsitewise.GetAssetPropertyAggregatesPaginator = client.get_paginator("get_asset_property_aggregates")
get_asset_property_value_history_paginator: iotsitewise.GetAssetPropertyValueHistoryPaginator = client.get_paginator("get_asset_property_value_history")
list_access_policies_paginator: iotsitewise.ListAccessPoliciesPaginator = client.get_paginator("list_access_policies")
list_asset_models_paginator: iotsitewise.ListAssetModelsPaginator = client.get_paginator("list_asset_models")
list_assets_paginator: iotsitewise.ListAssetsPaginator = client.get_paginator("list_assets")
list_associated_assets_paginator: iotsitewise.ListAssociatedAssetsPaginator = client.get_paginator("list_associated_assets")
list_dashboards_paginator: iotsitewise.ListDashboardsPaginator = client.get_paginator("list_dashboards")
list_gateways_paginator: iotsitewise.ListGatewaysPaginator = client.get_paginator("list_gateways")
list_portals_paginator: iotsitewise.ListPortalsPaginator = client.get_paginator("list_portals")
list_project_assets_paginator: iotsitewise.ListProjectAssetsPaginator = client.get_paginator("list_project_assets")
list_projects_paginator: iotsitewise.ListProjectsPaginator = client.get_paginator("list_projects")
```

## How it works

Fully automated [builder](https://github.com/vemel/mypy_boto3_builder) carefully generates
type annotations for each service, patiently waiting for `boto3` updates. It delivers
a drop-in type annotations for you and makes sure that:

- All available `boto3` services are covered.
- Each public class and method of every `boto3` service gets valid type annotations
  extracted from the documentation (blame `botocore` docs if types are incorrect).
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) for readability.